include 'interrupt.pxi'
include 'misc.pxi'
include 'decl.pxi'

cdef class ntl_ZZ:
    # See ZZ.pxd for definition of data members

    def __init__(self, x="0"):
        if not (x is _INIT):
            s = str(x)
            self.x = str_to_ZZ(s)

    def __dealloc__(self):
        del_ZZ(self.x)

    def __repr__(self):
        setsig()
        if sigsetjmp(_env,1): raise Exception
        return string(ZZ_to_str(self.x))

    def __mul__(ntl_ZZ self, other):
        cdef ntl_ZZ y
        if not isinstance(other, ntl_ZZ):
            other = ntl_ZZ(other)
        y = other
        setsig()
        if sigsetjmp(_env,1): raise Exception
        return make_ZZ(ZZ_mul(self.x, y.x))
            
    def __sub__(ntl_ZZ self, other):
        cdef ntl_ZZ y
        if not isinstance(other, ntl_ZZ):
            other = ntl_ZZ(other)
        y = other
        setsig()
        if sigsetjmp(_env,1): raise Exception
        return make_ZZ(ZZ_sub(self.x, y.x))

    def __add__(ntl_ZZ self, other):
        cdef ntl_ZZ y
        if not isinstance(other, ntl_ZZ):
            other = ntl_ZZ(other)
        y = other
        setsig()
        if sigsetjmp(_env,1): raise Exception
        return make_ZZ(ZZ_add(self.x, y.x))
            
    def __pow__(ntl_ZZ self, long e, ignored):
        setsig()
        if sigsetjmp(_env,1): raise Exception
        return make_ZZ(ZZ_pow(self.x, e))

    cdef set(self, void *y):
        self.x = <ZZ*> y
        
cdef public make_ZZ(ZZ* x):
    cdef ntl_ZZ y
    unsetsig()
    y = ntl_ZZ(_INIT)
    y.x = x
    return y
