cdef extern from "Python.h":
    object PyString_FromString(char *v)
    char* PyString_AsString(object string)

cdef extern from "stdlib.h":
    void free(void *ptr)

cdef extern from "wrap.h":
    #### ZZ
    struct ZZ
    ZZ* new_ZZ()
    ZZ* str_to_ZZ(char* s)
    void del_ZZ(ZZ* n)
    char* ZZ_to_str(ZZ* x)
    ZZ* ZZ_add(ZZ* x, ZZ* y)
    ZZ* ZZ_sub(ZZ* x, ZZ* y)
    ZZ* ZZ_mul(ZZ* x, ZZ* y)
    ZZ* ZZ_pow(ZZ* x, long e)

    #### ZZX
    struct ZZX
    ZZX* ZZX_init()
    ZZX* str_to_ZZX(char* s)
    char* ZZX_repr(ZZX* x)
    void ZZX_dealloc(ZZX* x)
    ZZX* ZZX_copy(ZZX* x)
    void ZZX_setitem(ZZX* x, long i, char* a)
    char* ZZX_getitem(ZZX* x, long i)
    ZZX* ZZX_add(ZZX* x, ZZX* y)
    ZZX* ZZX_sub(ZZX* x, ZZX* y)
    ZZX* ZZX_mul(ZZX* x, ZZX* y)
    ZZX* ZZX_div(ZZX* x, ZZX* y, int* divisible)
    ZZX* ZZX_mod(ZZX* x, ZZX* y)
    void ZZX_quo_rem(ZZX* x, ZZX* other, ZZX** r, ZZX** q)
    ZZX* ZZX_square(ZZX* x)
    int ZZX_equal(ZZX* x, ZZX* y)
    int ZZX_is_zero(ZZX* x)
    int ZZX_is_one(ZZX* x)
    int ZZX_is_monic(ZZX* x)
    ZZX* ZZX_neg(ZZX* x)
    ZZX* ZZX_left_shift(ZZX* x, long n)
    ZZX* ZZX_right_shift(ZZX* x, long n)
    char* ZZX_content(ZZX* x)
    ZZX* ZZX_primitive_part(ZZX* x)
    void ZZX_pseudo_quo_rem(ZZX* x, ZZX* y, ZZX** r, ZZX** q)
    ZZX* ZZX_gcd(ZZX* x, ZZX* y)
    ZZX* ZZX_xgcd(ZZX* x, ZZX* y, ZZ** r, ZZX** s, ZZX** t, int proof)
    long ZZX_degree(ZZX* x)
    char* ZZX_leading_coefficient(ZZX* x)
    char* ZZX_constant_term(ZZX* x)
    void ZZX_set_x(ZZX* x)
    int ZZX_is_x(ZZX* x)
    ZZX* ZZX_derivative(ZZX* x)
    ZZX* ZZX_reverse(ZZX* x)
    ZZX* ZZX_reverse_hi(ZZX* x, long hi)
    ZZX* ZZX_truncate(ZZX* x, long m)
    ZZX* ZZX_multiply_and_truncate(ZZX* x, ZZX* y, long m)
    ZZX* ZZX_square_and_truncate(ZZX* x, long m)
    ZZX* ZZX_invert_and_truncate(ZZX* x, long m)
    ZZX* ZZX_multiply_mod(ZZX* x, ZZX* y,  ZZX* modulus)
    ZZ* ZZX_trace_mod(ZZX* x, ZZX* y)
    char* ZZX_trace_list(ZZX* x)
    ZZ* ZZX_resultant(ZZX* x, ZZX* y, int proof)
    ZZ* ZZX_norm_mod(ZZX* x, ZZX* y, int proof)
    ZZ* ZZX_discriminant(ZZX* x, int proof)
    ZZX* ZZX_charpoly_mod(ZZX* x, ZZX* y, int proof)
    ZZX* ZZX_minpoly_mod(ZZX* x, ZZX* y)
    void ZZX_clear(ZZX* x)
    void ZZX_preallocate_space(ZZX* x, long n)
    

    #### mat_ZZ
    struct mat_ZZ
    mat_ZZ* new_mat_ZZ(long nrows, long ncols)
    void del_mat_ZZ(mat_ZZ* n)
    char* mat_ZZ_to_str(mat_ZZ* x)
    mat_ZZ* mat_ZZ_add(mat_ZZ* x, mat_ZZ* y)
    mat_ZZ* mat_ZZ_sub(mat_ZZ* x, mat_ZZ* y)
    mat_ZZ* mat_ZZ_mul(mat_ZZ* x, mat_ZZ* y)
    mat_ZZ* mat_ZZ_pow(mat_ZZ* x, long e)
    long mat_ZZ_nrows(mat_ZZ* x)
    long mat_ZZ_ncols(mat_ZZ* x)
    void mat_ZZ_setitem(mat_ZZ* x, int i, int j, ZZ* z)
    ZZ* mat_ZZ_getitem(mat_ZZ* x, int i, int j)
    ZZ* mat_ZZ_determinant(mat_ZZ* x, long deterministic)
    mat_ZZ* mat_ZZ_HNF(mat_ZZ* A, ZZ* D)
    ZZX* mat_ZZ_charpoly(mat_ZZ* A)
